﻿using System;
using Microsoft.AspNetCore.Builder;

namespace Surging.Core.Swagger.Builder
{
    public static class SwaggerBuilderExtensions
    {
        public static IApplicationBuilder UseSwagger(
            this IApplicationBuilder app,
            Action<SwaggerOptions> setupAction = null)
        {
            if (setupAction == null)
            {
                // Don't pass options so it can be configured/injected via DI container instead
                app.UseMiddleware<SwaggerMiddleware>();
            }
            else
            {
                // Configure an options instance here and pass directly to the middleware
                var options = new SwaggerOptions();
                setupAction.Invoke(options);

                app.UseMiddleware<SwaggerMiddleware>(options);
            }

            return app;
        }
    }
}